%{!?ksrc:      %define ksrcprv   0}
%{?ksrc:       %define ksrcprv   1}
%{!?kernel:    %define kernel    %(uname -r)}
%{!?ksrc:      %define ksrc      %(bash /usr/bin/fedora-kmodhelper srcdir -u %{kernel} 2> /dev/null)}

Summary:        The ALSA device files
Name:           alsa-driver
Epoch:          0
Version:        1.0.4
Release:        0.fdr.2.1

License:        GPL
Group:          System Environment/Kernel
URL:            http://www.alsa-project.org/
Source0:        ftp://ftp.alsa-project.org/pub/driver/alsa-driver-1.0.4.tar.bz2
Source1:        alsa-makedev.d.txt
Patch0:         %{name}-no-depmod.patch
Patch1:         %{name}-alsasound.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  fedora-rpmdevtools >= 0.1.7-0.fdr.5
%if ! %{ksrcprv}
BuildRequires:	kernel-source = 0:%(bash /usr/bin/fedora-kmodhelper verrel -u %{kernel} 2>/dev/null)
%endif

BuildRequires:	MAKEDEV 
Requires(post,preun): /sbin/chkconfig
# alsasound script needs some of the utils
Requires:       alsa-utils >= 0:1.0.1

%description
Advanced Linux Sound Architecture driver. Driver is fully compatible
with OSS/Lite, but contains many enhanced features.
Note: This package contains device entries, headers and documentation.

You need the kernel-module-alsa package suiteable for your kernel or
a 2.6 Kernel.

The following rpmbuild options can be used to build this package
for a specific kernel:
--define "kernel <uname -r>"
  Specify the `uname -r` string of the target kernel, for example:
  "kernel 2.4.20-5smp".  The default is `uname -r` for the running kernel.
--define "ksrc <sourcetree>"
  Specify the kernel source directory, for example:
  "ksrc /lib/modules/2.4.20-5smp/build".  The default is
  resolved from <kernel>. You need to define ksrc if you
  try to build against a custom kernel.


%package     -n kernel-module-alsa-%{kernel}
Summary:        ALSA Kernel modules (drivers)
Group:          System Environment/Kernel
Provides:       kernel-module
Provides:       kernel-module-alsa = %{epoch}:%{version}-%{release}
Requires:       alsa-driver >= 0:1.0.0
Requires(pre):  modutils
%if %(bash  /usr/bin/fedora-kmodhelper rhkernel -s %{ksrc} -u %{kernel} 2>/dev/null || echo 0)
Requires:       /boot/vmlinuz-%{kernel}
%endif


%description -n kernel-module-alsa-%{kernel}
This package contains ALSA kernel modules built for Linux kernel
%{kernel} for the %{_target_cpu} family of processors.


%prep
### Show diag and let kmodehelper check itself 
(
	set +ex 
	echo
	echo "###### Diagnostics:"
	echo "### rpm defines:"
	echo " kernel: %{kernel}"
	echo " ksrc:   %{ksrc}"
	echo
	echo "### $(basename /usr/bin/fedora-kmodhelper):"
	bash /usr/bin/fedora-kmodhelper diag -s "%{ksrc}" -p "%{_target_cpu}" -u "%{kernel}" %{?_without_waiting:--nowait}
) %{!?_without_waiting:&& sleep 10} || exit 1

%setup -q -n %{name}-%{version}
%patch0 -p0 -b .nodepmod
%patch1 -p0 -b .alsasound

%build
export CC="$(bash /usr/bin/fedora-kmodhelper cc -s %{ksrc} -p %{_target_cpu}  -u %{kernel})"

rhmodflags="$(bash /usr/bin/fedora-kmodhelper rhmodflags -s %{ksrc} -p %{_target_cpu}  -u %{kernel})"
rhkernel="$(bash /usr/bin/fedora-kmodhelper rhkernel -s %{ksrc} -p %{_target_cpu}  -u %{kernel})"

CFLAGS=
if [ "${rhkernel}" -eq 1 ]
then
	export CFLAGS="${rhmodflags}"
fi

%configure \
  --with-kernel="%{ksrc}" \
  --with-moddir=/lib/modules/%{kernel}/kernel/sound

# Race condition
if [ "${rhkernel}" -eq 1 ]
then
	%{__make} MODFLAGS="-DMODULE=1 ${rhmodflags}"
else
	%{__make} 
fi

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__make} DESTDIR=$RPM_BUILD_ROOT IUSER=`id -un` IGROUP=`id -gn` install

# Install and generate all the device stuff
install -m 644 -D %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d/alsa
cp -a %{_sysconfdir}/makedev.d/00macros \
  $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d/
%{__rm} -f device.list

# Create entry list
/dev/MAKEDEV -M \
  -c $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d \
  -d $RPM_BUILD_ROOT/dev \
  snd/controlC snd/seq snd/timer snd/hwC snd/midiC snd/pcmC aloadC aloadSEQ \
  | sed "s|$RPM_BUILD_ROOT||g" | sed "s|0600\,|0666\,|" > device.list

# We dont need this file anymore.
%{__rm} -f $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d/00macros

# Install initscript.
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -m 0755 utils/alsasound $RPM_BUILD_ROOT%{_initrddir}

# Remove from the included docs
%{__rm} -f doc/Makefile

%clean
%{__rm} -rf $RPM_BUILD_ROOT


%preun
if [ $1 -eq 0 ]; then
  /sbin/chkconfig --del alsasound
fi

%post -n kernel-module-alsa-%{kernel}
if [ "`uname -r`" = "%{kernel}" ] ; then
  depmod -a >/dev/null || :
fi

%post
if [ $1 -eq 1 ]; then
  /sbin/chkconfig --add alsasound
fi

%postun -n kernel-module-alsa-%{kernel}
if [ "`uname -r`" = "%{kernel}" ] ; then
  depmod -a >/dev/null || :
fi


%files -f device.list
%defattr(-,root,root,-)
%doc CARDS-STATUS COPYING FAQ TODO README WARNING
%doc doc/serialmidi.txt doc/SOUNDCARDS doc/README.1st
%dir /dev/snd
%{_includedir}/sound
%config %{_sysconfdir}/makedev.d/alsa
%config %{_initrddir}/alsasound

%files -n kernel-module-alsa-%{kernel}
%defattr(-,root,root,-)
%doc alsa-kernel/Documentation/*
/lib/modules/%{kernel}/kernel/sound


%changelog
* Wed May 04 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.4-0.fdr.2
- Use /etc/makedev.d/alsa from FC2T3 so alsa-driver doesn't conflict 
  during update FC1 -> FC2

* Sat Apr 03 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.4-0.fdr.1
- Update to 1.0.4
- Remove alsa-driver-kmodhelper, require fedora-rpmdevtools and use
  fedora-kmodhelper

* Mon Feb 09 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.2-0.fdr.5.c
- Change Build and configure-call based on suggestion by Ville Skyttä

* Thu Feb 05 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.2-0.fdr.4.c
- Update to 1.0.2c

* Tue Feb 03 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.2-0.fdr.3
- Update kmodhjelper to 0.98 without changes
- Try to fool cpu-detection of configure with rhmodflags
- Minor cleanups (some due to kmodhelper changes)

* Sun Feb 01 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.2-0.fdr.2
- Updated kmodhelper to merged version from Ville with a minor correction.
  Will be removed in a future version when next fedora-rpmtools was published.
- Don't route depmod errors to /dev/null

* Wed Jan 28 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.2-0.fdr.1
- reorganize diag-waiting in spec-file
- move sed awaying "custom" from spec-file to kmodhelper
- Update to 1.0.2

* Fri Jan 16 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.1-0.fdr.6
- Add missing post

* Fri Jan 16 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.1-0.fdr.5
- Rediff alsasound and add proper description 

* Fri Jan 16 2004 Michael Schwendt <mschwendt[AT]users.sf.net> - 0:1.0.1-0.fdr.5
- Install alsasound initscript (with modified patch from Planet CCRMA)
  and take care of it in preun/post.

* Thu Jan 15 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.1-0.fdr.4
- Fix missing -DMODULE=1 in kmodhelper

* Wed Jan 14 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.1-0.fdr.3
- Fix some bugs in spec and kmodhelper

* Mon Jan 12 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.1-0.fdr.2
- BuildRequires correct kernel-source, only when ksrc is provided don't
- "Correct" fix for snd.o problem

* Fri Jan 09 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.1-0.fdr.1
- Update to 1.0.1
- Remove serialmidi/tty-patch -- done by configure now
- add workaround for unresolved symbols in snd.o (workqueue)

* Thu Jan 01 2004 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.0-0.fdr.0.8.rc2
- polish spec-file and alsa-driver-kmodhelper

* Tue Dec 30 2003 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.0-0.fdr.0.7.rc2
- updated alsa-driver-kmodhelper to 0.95, add overview function again 

* Fri Dec 26 2003 Thorsten Leemhuis <fedora[AT]leemhuis.info> - 0:1.0.0-0.fdr.0.6.rc2
- updated alsa-driver-kmodhelper
- many minor changes so building against rh/fedora/custom kernels should be possible 
- show an kernel-diag-overview before build

* Sun Dec 21 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0.0-0.fdr.0.5.rc2
- Fix /boot/vmlinuz-%%{kernel} dependency.

* Sun Dec 21 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0.0-0.fdr.0.4.rc2
- Simplify specfile, use fedora-kmodhelper.

* Wed Dec 17 2003 Thorsten Leemhuis <fedora[AT]leemhuis.info> 0:1.0.0-0.fdr.0.3.rc2
- Changed description of kernel-driver-package
- Restructure Provides/Requires so both packages need each other

* Thu Dec 04 2003 Thorsten Leemhuis <fedora[AT]leemhuis.info> 0:1.0.0-0.fdr.0.2.rc2
- Update to 1.0.0rc2
- added macro kmpackname -- SMP builds should be named correctly now
- some minor corrections in style

* Thu Dec 04 2003 Thorsten Leemhuis <fedora[AT]leemhuis.info> 0:1.0.0-0.fdr.0.1.rc1
- Update to 1.0.0rc1
- Build with gcc32
- removed some ksmp macros to name package kernel-driver-alsa-(uname-r)...

* Wed Aug 20 2003 Dams <anvil[AT]livna.org> 0:0.9.6-0.fdr.3
- kernel-module-name -> kernel-module-alsa
- Applied patch for atomic read to allow build on severn

* Mon Aug 18 2003 Dams <anvil[AT]livna.org> 0:0.9.6-0.fdr.2
- s/arch/_target/
- Race conditions in makefile, do not use smp_mflags

* Thu Aug 14 2003 Dams <anvil[AT]livna.org>
- Initial build. Partially based upon Matthias spec file
